#include <mpi.h>
#include <cstdio>
#include <cstdlib>

#define NMAX 100   //максимальное количество уравнений у каждого процесса
#define NPMAX 10   // максимадьное количество процессов

#define comm MPI_COMM_WORLD

#define LMAX 23    //максимадьное количество блоков

#define LMMAX LMAX*LMAX

int IP,NP;          //номер процесса, количество процессов
MPI_Status status;
int NN[NPMAX],mm0[NPMAX+1];   //количпство уравнений для каждого процесса, количество уравнений у всех предыдущих процессов

int L,M;            //количество блоков, длина блока
FILE *fp;           //файловая переменная
double X[LMMAX],XX[LMMAX];  //массив, содержащий вектор-столбец, массив для сборки результатов со всех сегментов
int go=0;           //счетчик шагов

int N,m0,m1,m2,n,XXcnt[NPMAX],XXdsp[NPMAX];  //количество уравнений у каждого процесса, номер блока в глобальной нумерации, номер первого блока в  
                                             //сегменте, номер последнего блока в сегменте, количество шагов по времени, размер сегмента, его смещение в //массиве XX

#include "RK4.cpp"

void f(float t,int m0,int m1,int m2,double* x,double* dx) {
        int m11,m21;
	if(m0==0) { for(int j=0;j<M;j++) {
		dx[m1*M+j]=0.;             // Граничные условия: левый край
	} m11=m1+1;} else m11=m1;
	if(m0+(m2-m1)==L-1) { for(int j=0;j<M;j++) {
		dx[m2*M+j]=0.;             // Граничные условия: правый край
	} m21=m2-1;} else m21=m2;
	for(int i=m11;i<=m21;i++) {
	       	dx[i*M+0]=0.; 	           // Граничные условия: нижний край
		dx[i*M+(M-1)]=0.;	   // Граничные условия: верхний край
	}
	for(int i=m11;i<=m21;i++) for(int j=1;j<M-1;j++) { // Внутренние производные
		dx[i*M+j]=x[(i-1)*M+j]+x[(i+1)*M+j]+x[i*M+j-1]+x[i*M+j+1]-4*x[i*M+j];
        	if(m0+(i-m1)==L/2 && j==M/2) dx[i*M+j]=dx[i*M+j]+0.1;
	}
}

void g(float t,int m0,int m1,int m2,double* x,double* dx) {

	MPI_Gatherv(&x[m1*M],XXcnt[IP],MPI_DOUBLE,XX,XXcnt,XXdsp,MPI_DOUBLE,0,comm);

	if(IP==0) {
		for(int i=0;i<L;i++) for(int j=0;j<M;j++) { 			// печать результатов шага
			fprintf(fp," %f",XX[i*M+j]);
		} fprintf(fp,"\n");
	}

	go=go-1;
}

int main() {

  float t,ht;  //время, шаг по времени

	fp= fopen("RK4test.par", "r");

		fscanf(fp,"%d %d %d %f",&L,&M,&n,&ht);

	fclose(fp);


  	int argc = 0; char **argv = NULL;
  	MPI_Init(&argc, &argv);
  	MPI_Comm_size( comm, &NP ); 
  	MPI_Comm_rank( comm, &IP ); 

	// Разметка MPI-процессов
	
  	for(int i=0; i<NP; i++) {
    		NN[i]=L/NP;                   //NN[i] - количество уравнений у i - го процесса
    		if (i<(L%NP)) NN[i]=NN[i]+1;
  	}
  	mm0[0]=0;
  	for(int i=1; i<NP; i++) {
    		mm0[i]=mm0[i-1]+NN[i-1];
  	}
  	m0=mm0[IP];
  	N=NN[IP];              //N - количество уравнений у каждого процесса

  	m1=1; //m1 - номер первого уравнения в каждом процессе
  	m2=N; //m2 - номер последнего уравнения в каждом процессе

  	for(int i=0; i<NP; i++) {                          //  для использования в операторе     MPI_Gatherv 
    		XXcnt[i]=NN[i]*M; XXdsp[i]=mm0[i]*M;       //  XXcnt — массив длин всех сегментов,,
  	}                                                  //  XXdisp — массив смещений всех сегментов при помещении в сборочный массив XX

  	printf(" IP=%2d  NP=%2d    N=%4d m0=%2d m1=%2d m2=%2d   n=%3d\n",IP,NP,N,m0,m1,m2,n);


//-----------------------------------------------------------------------------------------

	//заполнение начальных значений

	for(int i=m1;i<=m2;i++) for(int j=0;j<M;j++) {
		X[i*M+j]=0.;
	}


	if(IP==0) fp= fopen("RK4test.out", "w");									

	t=0.; go=n; while(go>0) {

		RK4(&f,&g,M,t,ht,m0,m1,m2,X,X); t=t+ht;	// один шаг интегрирования
	}

	if(IP==0) fclose(fp);


// Конец MPI

//	if(IP==0) remove("RK4test.par");

        MPI_Finalize();

  	return 0;
}
